package com.mr.test;


import android.util.Base64;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;
import java.io.IOException;
import java.security.SecureRandom;

// java工程使用

// android工程使用
// import android.annotation.SuppressLint;
// import android.util.Base64;


public class DesUtil {  
   
    private final static String DES = "DES";
    
    /** 
     * Description 根据键值进行加密 
     * @param data  
     * @param key  加密键byte数组 
     * @return 
     * @throws Exception
     */  
    public static String encrypt( String data, String key) throws Exception {
        byte[] bt = encrypt(data.getBytes( "gbk"), key.getBytes());  
        String strs = Base64.encodeToString( bt, Base64.DEFAULT);
        return strs;  
    }  
   
    /** 
     * Description 根据键值进行解密 
     * @param data 
     * @param key  加密键byte数组 
     * @return 
     * @throws IOException
     * @throws Exception
     */  
    public static String decrypt( String data, String key) throws IOException,
            Exception {
        if (data == null)  
            return null;  
        
        byte[] buf = Base64.decode(data.getBytes(), Base64.DEFAULT);
        byte[] bt = decrypt(buf,key.getBytes());
        return new String(bt, "gbk");
    }  
   
    /** 
     * Description 根据键值进行加密 
     * @param data 
     * @param key  加密键byte数组 
     * @return 
     * @throws Exception
     */  
    public static byte[] encrypt(byte[] data, byte[] key) throws Exception {
        // 生成一个可信任的随机数源  
        SecureRandom sr = new SecureRandom();
   
        // 从原始密钥数据创建DESKeySpec对象  
        DESKeySpec dks = new DESKeySpec(key);
   
        // 创建一个密钥工厂，然后用它把DESKeySpec转换成SecretKey对象  
        SecretKeyFactory keyFactory = SecretKeyFactory.getInstance(DES);
        SecretKey securekey = keyFactory.generateSecret(dks);
   
        // Cipher对象实际完成加密操作  
        Cipher cipher = Cipher.getInstance(DES);
   
        // 用密钥初始化Cipher对象  
        cipher.init( Cipher.ENCRYPT_MODE, securekey, sr);
   
        return cipher.doFinal(data);  
    }  
       
       
    /** 
     * Description 根据键值进行解密 
     * @param data 
     * @param key  加密键byte数组 
     * @return 
     * @throws Exception
     */  
    public static byte[] decrypt(byte[] data, byte[] key) throws Exception {
        // 生成一个可信任的随机数源  
        SecureRandom sr = new SecureRandom();
   
        // 从原始密钥数据创建DESKeySpec对象  
        DESKeySpec dks = new DESKeySpec(key);
   
        // 创建一个密钥工厂，然后用它把DESKeySpec转换成SecretKey对象  
        SecretKeyFactory keyFactory = SecretKeyFactory.getInstance(DES);
        SecretKey securekey = keyFactory.generateSecret(dks);
   
        // Cipher对象实际完成解密操作  
        Cipher cipher = Cipher.getInstance(DES);
   
        // 用密钥初始化Cipher对象  
        cipher.init( Cipher.DECRYPT_MODE, securekey, sr);
   
        return cipher.doFinal(data);  
    }  
}  